
/* 
NewsFleX offline NNTP news reader
NewsFleX is registered Copyright (C) 1997-2002 <Jan Panteltje>
email: panteltje@yahoo.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "NewsFleX.h"

extern FD_NewsFleX *fdui;


int show_fonts_form()
{
if(debug_flag)
	{
	printf("show_fonts_form(): arg none\n");
	}

if(fonts_form_shown_flag) return 0;

set_font_radio_buttons(fonts_mode);

show_fonts(SHOW_TOP);

fl_show_form(fdui -> fonts_form, FL_PLACE_CENTER | FL_FREE_SIZE,  FL_UP_FRAME, "NewsFleX: fonts");

fonts_form_shown_flag = 1;

return 1;
} /* end function show_fonts_form */


void addit(const char *str)   
{  
char temp[1024];

//sprintf(temp, "@f@C0%s", str);
sprintf(temp, "@C0%s", str);

fl_add_browser_line(fdui -> fonts_form_browser, temp); 
} /* end function add_it */
 

int add_system_fonts()
{
int a, j, k;
FILE *pptr;
char temp[TEMP_SIZE];
FILE *fptr;
char str[16][80];
char *ptr;

if(debug_flag)
	{
	printf("add_system_fonts(): arg none\n");
	}

/* first add the xforms fonts to the structure */
max_fonts = fl_enumerate_fonts(add_xforms_font, 1);

/* execute xlsfonts */
sprintf(temp, "xlsfonts > %s/.NewsFleX/fontlist.txt", home_dir);
pptr = popen(temp, "r");
pclose(pptr);

/* read the created font list */
sprintf(temp, "%s/.NewsFleX/fontlist.txt", home_dir);
fptr = fopen(temp, "r");
if(! fptr)
	{
	fl_show_alert("Could not open file", temp, "No system fonts", 0);

	return 0;
	}

while(1)
	{
	/* closes file if EOF */
	a = readline(fptr, temp);
	if(a == EOF) break;

	/*
	-adobe-courier-bold-o-normal--10-100-75-75-m-60-iso8859-15
	 1     2       3    4 5     6 7  8   9  10 11 12 13     14
	*/

	ptr = temp;
	for(j = 0; j < 16; j++)
		{
		/* copy field */
		k = 0;
		while(1)
			{
			/* test for end of font */
			if(*ptr == 0) break;

			/* test for end of field */
			if(*ptr == '-') break;

			/* copy character */
			str[j][k] = *ptr;

			ptr++;
			k++;
			} /* end while all characters in a field */		

		/* string termination */
		str[j][k] = 0;

		if(debug_flag)
			{
			printf("add_system_fonts(): a=%d str[%d]=%s\n", a, j, str[j]);
			}

		/* end of font */
		if(*ptr == 0) break;

		/* point past '-' */
		ptr++;

		} /* end for all fields */

	/* some filters */

	/* only size 10 */
	if(atoi(str[7]) != 10) continue;

	/* only normal or recursive */	
	if(
	(strcmp(str[4], "r") != 0)
	&& (strcmp(str[4], "o") != 0)
	&& (strcmp(str[4], "i") != 0)
	)
		{
		continue;
		}

	/*
	-adobe-courier-bold-o-normal--10-100-75-75-m-60-iso8859-15
	 1     2       3    4 5     6 7  8   9  10 11 12 13     14
	-adobe-courier-*   -*-*     -*-*-?  -* -* -*-* -*      -*
	*/

	/* make a suitable entry for xforms */
	sprintf(temp, "-%s-%s-%s-%s-*-*-*-?-*-*-*-*-%s-%s",\
	str[1], str[2], str[3], str[4], str[13], str[14]);

	if(debug_flag)
		{
		printf("add_system_fonts(): adding=%s\n", temp);
		}
		
	/*
	add to structure first, xlsfonts seems to create double entries.
	keep iso8895 and 15 separate for use later in posting header and
    to select a font.
	*/
	add_X_font(temp, str[13], atoi(str[14]) );
	} /* end while all fonts in list */


sort_fonts();

/* 
enumerate browser_lines !!!, else lookup for font number in setup will fail.
*/
show_fonts(SHOW_TOP);

return 1;
} /* add function add_system_fonts */


int set_article_fonts(int font)
{
int a;
char *ptr;
char temp[80];
FILE *pptr;
int iso_number;
int iso_extention;

if(debug_flag)
	{
	printf("set_article_fonts(): arg font=%d using used_font=%d\n",\
	font, used_font);
	}

if(font == used_font)
	{
	if(debug_flag)
		{
		printf("set_article_fonts(): returning font=used_font\n");
		}

	return 1;
	}

/* set the global */
used_font = font;

/* get the iso info of the current used font for the posting header */
ptr = line_to_iso(font, &iso_extention);
if(! ptr)
	{
	if(debug_flag)
		{
		printf("line_to_iso_failed\n");
		}

	return 0;
	}

if(debug_flag)
	{
	printf("set_article_fonts(): ISO ptr=%s\n", ptr);
	}

a = sscanf(ptr + 3, "%d", &iso_number);
if(strncasecmp(ptr, "ISO", 3) == 0)
	{
	sprintf(temp, "charset=ISO-%d-%d", iso_number, iso_extention);
	}
/* testing with non ISO too? */
//else if(strncasecmp(ptr, "koi", 3) == 0)
//	{
//	sprintf(temp, "charset=KOI-%d-%d", iso_number, iso_extention);
//	}
else
	{
	strcpy(temp, ""); 
	}

if(used_charset) free(used_charset);
used_charset = strsave(temp);
if(! used_charset) return 0;
if(debug_flag)
	{
	printf("set_article_fonts(): setting used_charset=%s\n", used_charset);
	}

if(font > 15)
	{
	ptr = line_to_font(font);
	if(! ptr)
		{
		fl_show_alert("could not set article font", "using default", "", 0);

		return 0;
		}

	if(debug_flag)
		{
		printf("set_article_fonts(): setting font 17 ptr=%p (%s) font=%d\n",\
		ptr, ptr, font);
 		}

	a = fl_set_font_name(17, ptr);
	if(a < 0)
		{
		fl_show_alert("fl_set_font_name() failed", "", "", 0);

		return 0;
		}

	/* use position 17 */
	font = 17;
	} /* end if requested font > 15 */

/* if font 0 selected */
if(font < 0) font = 0;

if(debug_flag)
	{
	printf("set_article_fonts(): setting articles lstyle for font=%d\n",\
	font);
	}

/* inputs */
fl_set_object_lstyle(fdui -> article_body_input_field, font);
fl_set_object_lstyle(fdui -> posting_body_editor, font);

fl_set_object_lstyle(fdui -> posting_header_form_input_field, font);
fl_set_object_lstyle(fdui -> article_header_form_input_field, font);

fl_set_object_lstyle(fdui -> summary_editor_input_field, font);
fl_set_object_lstyle(fdui -> global_custom_headers_editor_input_field, font);
fl_set_object_lstyle(fdui -> local_custom_headers_editor_input_field, font);

fl_set_object_lstyle(fdui -> special_characters_form_input, font);

fl_set_object_lstyle(fdui -> helpers_form_input, font);

/* on some fonts text becomes invisible */
//fl_set_object_lstyle(fdui -> posting_to_input_field, font);
//fl_set_object_lstyle(fdui -> posting_subject_input_field, font);
//fl_set_object_lstyle(fdui -> posting_attachment_input_field, font);
//fl_set_object_lstyle(fdui -> posting_alt_editor_command_input_field, font);
//fl_set_object_lstyle(fdui -> secret_input_form_input, font);

XSync(fl_get_display(), 0);

/* refresh the X screen to show the new fonts */
sprintf(temp, "xrefresh");
pptr = popen(temp, "w");
pclose(pptr);

return 1;
} /* end function set_article_fonts */


int set_global_fonts(int font)
{
int a;
char *ptr;
FILE *pptr;
char temp[80];

if(debug_flag)
	{
	printf("set_global_fonts(): arg font=%d\n", font);
	}

get_max_fonts(&a);
if(font > a)
	{
	printf(\
"error requested global font number %d to high, only %d fonts loaded\n",\
	font, a);
	}

if(font > 15)
	{
	ptr = line_to_font(font);
	if(! ptr)
		{
		sprintf(temp, "%d", font);
		fl_show_alert(\
		"could not set global font", temp, "using default", 0);

		return 0;
		}

	if(debug_flag)
		{
		printf("set_global_fonts(): setting font 16 ptr=%p (%s) font=%d\n",\
		ptr, ptr, font);
 		}

	a = fl_set_font_name(16, ptr);
	if(a < 0)
		{
		fl_show_alert("fl_set_font_name() failed", "", "", 0);

		return 0;
		}

	/* use position 16 */
	font = 16;
	} /* end if requested font > 15 */

/* if font 0 selected */
if(font < 0) font = 0;

if(debug_flag)
	{
	printf("set_gobal_fonts(): setting global lstyle for font=%d\n",\
	font);
	}

/* text in pull down menus */
fl_setpup_default_fontstyle(font);


/* browsers */
fl_set_browser_fontstyle(fdui -> group_list_browser, font);
fl_set_browser_fontstyle(fdui -> article_list_browser, font);
fl_set_browser_fontstyle(fdui -> posting_list_browser, font);
fl_set_browser_fontstyle(fdui -> filter_list_browser, font);
fl_set_browser_fontstyle(fdui -> url_form_browser, font);
fl_set_browser_fontstyle(fdui -> incoming_mail_form_browser, font);
fl_set_browser_fontstyle(fdui -> newsserver_form_browser, font);
fl_set_browser_fontstyle(fdui -> posting_period_form_browser, font);
fl_set_browser_fontstyle(fdui -> fonts_form_browser, font);

/* font buttons */
fl_set_object_lstyle(fdui -> helpers_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> helpers_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> browser_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> browser_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> error_log_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> error_log_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> special_characters_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> special_characters_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> summary_editor_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> summary_editor_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> coding_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> coding_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> article_header_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> article_header_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> posting_header_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> posting_header_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> posting_editor_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> posting_editor_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> filter_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> filter_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> custom_headers_editor_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> custom_headers_editor_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> url_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> url_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> incoming_mail_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> incoming_mail_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> newsserver_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> newsserver_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> posting_period_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> posting_period_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> fonts_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> fonts_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> secret_input_form_cancel_button, font);
fl_set_object_lstyle(fdui -> secret_input_form_ok_button, font);
fl_set_object_lstyle(fdui -> secret_input_form_clear_button, font);

/* not used or not defined font buttons */
//fl_set_object_lstyle(fdui -> desc_input_fontsize_up_button, font);
//fl_set_object_lstyle(fdui -> desc_input_fontsize_down_button, font);
//fl_set_object_lstyle(fdui -> search_fontsize_up_button, font);
//fl_set_object_lstyle(fdui -> search_fontsize_down_button, font);
//fl_set_object_lstyle(fdui -> highlight_fontsize_up_button, font);
//fl_set_object_lstyle(fdui -> highlight_fontsize_down_button, font);

//fl_set_object_lstyle(fdui -> setup_form_fontsize_up_button, font);
//fl_set_object_lstyle(fdui -> setup_form_fontsize_down_button, font);

//fl_set_object_lstyle(fdui -> desc_input_fontsize_up_button, font);
//fl_set_object_lstyle(fdui -> desc_input_fontsize_down_button, font);

/* inputs */
/*
fl_set_object_lstyle(fdui -> setup_form_local_mail_check_interval_input_field, font);
fl_set_object_lstyle(fdui -> setup_form_posting_wrap_chars_input_field, font);
fl_set_object_lstyle(fdui -> setup_form_posting_source_input_field, font);
fl_set_object_lstyle(fdui -> server_username_input_field, font);
fl_set_object_lstyle(fdui -> server_password_input_field, font);
fl_set_object_lstyle(fdui -> tab_size_input_field, font);
fl_set_object_lstyle(fdui -> auto_connect_to_net_input_field, font);
fl_set_object_lstyle(fdui -> auto_disconnect_from_net_input_field, font);
fl_set_object_lstyle(fdui -> auto_execute_application_input_field, font);
fl_set_object_lstyle(fdui -> pid_test_input_field, font);
fl_set_object_lstyle(fdui -> get_new_headers_time_input_field, font);
fl_set_object_lstyle(fdui -> news_server_input_field, font);
fl_set_object_lstyle(fdui -> mail_server_input_field, font);
fl_set_object_lstyle(fdui -> news_server_port_input_field, font);
fl_set_object_lstyle(fdui -> mail_server_port_input_field, font);
fl_set_object_lstyle(fdui -> real_name_input_field, font);
fl_set_object_lstyle(fdui -> user_email_input_field, font);
fl_set_object_lstyle(fdui -> connect_to_news_server_timeout_input_field, font);
fl_set_object_lstyle(fdui -> connect_to_mail_server_timeout_input_field, font);
fl_set_object_lstyle(fdui -> maximum_headers_per_group_input_field, font);
*/

//fl_set_object_lstyle(fdui -> article_body_input_field, font);
//fl_set_object_lstyle(fdui -> summary_editor_input_field, font);
//fl_set_object_lstyle(fdui -> coding_form_input_field, font);
//fl_set_object_lstyle(fdui -> posting_header_form_input_field, font);
//fl_set_object_lstyle(fdui -> article_header_form_input_field, font);
//fl_set_object_lstyle(fdui -> posting_alt_editor_command_input_field, font);
//fl_set_object_lstyle(fdui -> posting_to_input_field, font);
//fl_set_object_lstyle(fdui -> posting_subject_input_field, font);
//fl_set_object_lstyle(fdui -> posting_attachment_input_field, font);
//fl_set_object_lstyle(fdui -> posting_body_editor, font);
//fl_set_object_lstyle(fdui -> posting_editor_color_box, font);
//fl_set_object_lstyle(fdui -> search_groups_input_field, font);
//fl_set_object_lstyle(fdui -> search_keywords_input_field, font);
//fl_set_object_lstyle(fdui -> filter_password_input_field, font);
//fl_set_object_lstyle(fdui -> filter_groups_input_field, font);
//fl_set_object_lstyle(fdui -> filter_keywords_input_field, font);
//fl_set_object_lstyle(fdui -> global_custom_headers_editor_input_field, font);
//fl_set_object_lstyle(fdui -> local_custom_headers_editor_input_field, font);
//fl_set_object_lstyle(fdui -> url_form_input_field, font);
//fl_set_object_lstyle(fdui -> url_form_browser_command_input_field, font);
//fl_set_object_lstyle(fdui -> url_form_depth_input_field, font);
//fl_set_object_lstyle(fdui -> url_form_search_input_field, font);
//fl_set_object_lstyle(fdui -> highlight_keywords_input_field, font);
//fl_set_object_lstyle(fdui -> newsserver_form_input_field, font);
//fl_set_object_lstyle(fdui -> posting_period_form_input_field, font);
//fl_set_object_lstyle(fdui -> helpers_form_input, font);
//fl_set_object_lstyle(fdui -> desc_input, font);
//fl_set_object_lstyle(fdui -> error_log_form_input, font);
//fl_set_object_lstyle(fdui -> special_characters_form_input, font);
//fl_set_object_lstyle(fdui -> special_characters_form_clear_button, font);

/* menus */
fl_set_object_lstyle(fdui -> groups_menu, font);
fl_set_object_lstyle(fdui -> article_menu, font);
fl_set_object_lstyle(fdui -> posting_menu, font);
fl_set_object_lstyle(fdui -> options_menu, font);
fl_set_object_lstyle(fdui -> online_menu, font);
fl_set_object_lstyle(fdui -> file_menu, font);
fl_set_object_lstyle(fdui -> window_menu, font);
fl_set_object_lstyle(fdui -> posting_coding_menu, font);

/* form titles */
fl_set_object_lstyle(fdui -> setup_form_title, font);
fl_set_object_lstyle(fdui -> helpers_form_title, font);
fl_set_object_lstyle(fdui -> desc_form_title, font);
fl_set_object_lstyle(fdui -> error_log_form_form_title, font);
fl_set_object_lstyle(fdui -> summary_editor_form_title, font);
fl_set_object_lstyle(fdui -> coding_form_title, font);
fl_set_object_lstyle(fdui -> posting_header_form_title, font);
fl_set_object_lstyle(fdui -> article_header_form_title, font);
fl_set_object_lstyle(fdui -> posting_form_title, font);
fl_set_object_lstyle(fdui -> search_form_title, font);
fl_set_object_lstyle(fdui -> filter_form_title, font);
fl_set_object_lstyle(fdui -> question_form_title, font);
fl_set_object_lstyle(fdui -> custom_headers_form_title, font);
fl_set_object_lstyle(fdui -> highlight_form_title, font);
fl_set_object_lstyle(fdui -> url_form_title, font);
fl_set_object_lstyle(fdui -> incoming_mail_form_title, font);
fl_set_object_lstyle(fdui -> newsserver_form_title, font);
fl_set_object_lstyle(fdui -> posting_period_form_title, font);
fl_set_object_lstyle(fdui -> fonts_form_title, font);
//fl_set_object_lstyle(fdui -> special_characters_form_form_title, font);
fl_set_object_lstyle(fdui -> secret_input_form_title, font);

/* texts */
fl_set_object_lstyle(fdui -> width_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_insert_headers_text, font);
fl_set_object_lstyle(fdui -> setup_form_get_by_message_id_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_check_local_mail_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_show_only_once_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_do_not_use_sendmail_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_lines_first_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_cut_off_sig_in_reply_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_beep_on_mail_button_text, font);
fl_set_object_lstyle(fdui -> setup_form_autosig_button_text, font);             
fl_set_object_lstyle(fdui -> desc_button_text, font);
fl_set_object_lstyle(fdui -> filter_form_no_text, font);
fl_set_object_lstyle(fdui -> question_text, font);

/* text displays */
fl_set_object_lstyle(fdui -> description_display, font);
fl_set_object_lstyle(fdui -> command_status_display, font);
fl_set_object_lstyle(fdui -> line_status_display, font);
fl_set_object_lstyle(fdui -> line_speed_display, font);
fl_set_object_lstyle(fdui -> mail_display, font);

/* accept buttons */
fl_set_object_lstyle(fdui -> setup_accept_button, font);
fl_set_object_lstyle(fdui -> helpers_form_accept_button, font);
fl_set_object_lstyle(fdui -> desc_accept_button, font);
fl_set_object_lstyle(fdui -> error_log_form_accept_button, font);
fl_set_object_lstyle(fdui -> special_characters_form_accept_button, font);
fl_set_object_lstyle(fdui -> summary_editor_accept_button, font);
fl_set_object_lstyle(fdui -> search_accept_button, font);
fl_set_object_lstyle(fdui -> filter_accept_button, font);
fl_set_object_lstyle(fdui -> custom_headers_editor_accept_button, font);
fl_set_object_lstyle(fdui -> url_form_accept_button, font);
fl_set_object_lstyle(fdui -> highlight_accept_button, font);
fl_set_object_lstyle(fdui -> newsserver_form_accept_button, font);
fl_set_object_lstyle(fdui -> fonts_form_accept_button, font);
fl_set_object_lstyle(fdui -> article_header_form_cancel_button, font);
//fl_set_object_lstyle(fdui -> incoming_mail_form_accept_button, font);

/* cancel buttons */
fl_set_object_lstyle(fdui -> setup_cancel_button, font);
fl_set_object_lstyle(fdui -> desc_cancel_button, font);
fl_set_object_lstyle(fdui -> helpers_form_cancel_button, font);
fl_set_object_lstyle(fdui -> error_log_form_cancel_button, font);
fl_set_object_lstyle(fdui -> summary_editor_cancel_button, font);
fl_set_object_lstyle(fdui -> coding_form_cancel_button, font);
fl_set_object_lstyle(fdui -> posting_header_form_cancel_button, font);
fl_set_object_lstyle(fdui -> posting_cancel_button, font);
fl_set_object_lstyle(fdui -> search_cancel_button, font);
fl_set_object_lstyle(fdui -> filter_cancel_button, font);
fl_set_object_lstyle(fdui -> custom_headers_editor_cancel_button, font);
fl_set_object_lstyle(fdui -> url_form_cancel_button, font);
fl_set_object_lstyle(fdui -> highlight_cancel_button, font);
fl_set_object_lstyle(fdui -> incoming_mail_form_cancel_button, font);
//fl_set_object_lstyle(fdui -> special_characters_form_cancel_button, font);
//fl_set_object_lstyle(fdui -> newsserver_form_cancel_button, font);
//fl_set_object_lstyle(fdui -> posting_period_form_cancel_button, font);

/* other buttons */
fl_set_object_lstyle(fdui -> html_decode_button, font);
fl_set_object_lstyle(fdui -> launche_button, font);
fl_set_object_lstyle(fdui -> stop_button, font);
fl_set_object_lstyle(fdui -> width_button, font);
fl_set_object_lstyle(fdui -> view_article_header_button, font);
fl_set_object_lstyle(fdui -> group_list_button, font);
fl_set_object_lstyle(fdui -> article_list_button, font);
fl_set_object_lstyle(fdui -> article_body_button, font);
fl_set_object_lstyle(fdui -> next_thread_button, font);
fl_set_object_lstyle(fdui -> next_unread_button, font);
fl_set_object_lstyle(fdui -> setup_form_insert_headers_button, font);
fl_set_object_lstyle(fdui -> setup_form_get_by_message_id_button, font);
fl_set_object_lstyle(fdui -> setup_form_show_only_once_button, font);
fl_set_object_lstyle(fdui -> setup_form_check_local_mail_button, font);
fl_set_object_lstyle(fdui -> setup_form_do_not_use_sendmail_button, font);
fl_set_object_lstyle(fdui -> setup_form_lines_first_button, font);
fl_set_object_lstyle(fdui -> setup_form_cut_off_sig_in_reply_button, font);
fl_set_object_lstyle(fdui -> setup_form_beep_on_mail_button, font);
fl_set_object_lstyle(fdui -> desc_button, font);
fl_set_object_lstyle(fdui -> auto_connect_to_net_button, font);
fl_set_object_lstyle(fdui -> auto_disconnect_from_net_button, font);
fl_set_object_lstyle(fdui -> auto_execute_application_button, font);
fl_set_object_lstyle(fdui -> get_new_headers_enable_button, font);
fl_set_object_lstyle(fdui -> setup_form_posting_source_button, font);
fl_set_object_lstyle(fdui -> error_log_form_clear_button, font);
fl_set_object_lstyle(fdui -> summary_editor_insert_file_button, font);
fl_set_object_lstyle(fdui -> summary_editor_write_file_button, font);
fl_set_object_lstyle(fdui -> summary_editor_clear_button, font);
fl_set_object_lstyle(fdui -> posting_send_now_button, font);
fl_set_object_lstyle(fdui -> posting_send_later_button, font);
fl_set_object_lstyle(fdui -> posting_attach_file_button, font);
fl_set_object_lstyle(fdui -> posting_insert_file_button, font);
fl_set_object_lstyle(fdui -> posting_cross_post_button, font);
fl_set_object_lstyle(fdui -> posting_write_file_button, font);
fl_set_object_lstyle(fdui -> posting_editor_signature_button, font);
fl_set_object_lstyle(fdui -> posting_editor_clear_button, font);
fl_set_object_lstyle(fdui -> posting_summary_button, font);
fl_set_object_lstyle(fdui -> posting_add_url_button, font);
fl_set_object_lstyle(fdui -> posting_special_character_button, font);
fl_set_object_lstyle(fdui -> posting_alt_editor_button, font);
fl_set_object_lstyle(fdui -> posting_custom_headers_button, font);
fl_set_object_lstyle(fdui -> search_postings_button, font);
fl_set_object_lstyle(fdui -> search_articles_button, font);
fl_set_object_lstyle(fdui -> search_headers_button, font);
fl_set_object_lstyle(fdui -> search_headers_from_button, font);
fl_set_object_lstyle(fdui -> search_headers_to_button, font);
fl_set_object_lstyle(fdui -> search_headers_subject_button, font);
fl_set_object_lstyle(fdui -> search_headers_references_button, font);
fl_set_object_lstyle(fdui -> search_headers_others_button, font);
fl_set_object_lstyle(fdui -> search_bodies_button, font);
fl_set_object_lstyle(fdui -> search_attachments_button, font);
fl_set_object_lstyle(fdui -> search_case_sensitive_button, font);
fl_set_object_lstyle(fdui -> filter_enable_button, font);
fl_set_object_lstyle(fdui -> filter_postings_button, font);
fl_set_object_lstyle(fdui -> filter_articles_button, font);
fl_set_object_lstyle(fdui -> filter_headers_button, font);
fl_set_object_lstyle(fdui -> filter_headers_from_button, font);
fl_set_object_lstyle(fdui -> filter_headers_to_button, font);
fl_set_object_lstyle(fdui -> filter_headers_subject_button, font);
fl_set_object_lstyle(fdui -> filter_headers_newsgroups_button, font);
fl_set_object_lstyle(fdui -> filter_headers_others_button, font);
fl_set_object_lstyle(fdui -> filter_bodies_button, font);
fl_set_object_lstyle(fdui -> filter_groups_button, font);
fl_set_object_lstyle(fdui -> filter_list_browser_delete_button, font);
fl_set_object_lstyle(fdui -> filter_list_browser_new_button, font);
fl_set_object_lstyle(fdui -> filter_attachments_button, font);
fl_set_object_lstyle(fdui -> filter_case_sensitive_button, font);
fl_set_object_lstyle(fdui -> filter_keywords_and_button, font);
fl_set_object_lstyle(fdui -> filter_keywords_not_button, font);
fl_set_object_lstyle(fdui -> filter_keywords_only_button, font);
fl_set_object_lstyle(fdui -> filter_allow_button, font);
fl_set_object_lstyle(fdui -> filter_headers_show_button, font);
fl_set_object_lstyle(fdui -> filter_bodies_show_button, font);
fl_set_object_lstyle(fdui -> filter_attachments_show_button, font);
fl_set_object_lstyle(fdui -> filter_groups_show_button, font);
fl_set_object_lstyle(fdui -> question_yes_button, font);
fl_set_object_lstyle(fdui -> question_no_button, font);
fl_set_object_lstyle(fdui -> global_custom_headers_enable_button, font);
fl_set_object_lstyle(fdui -> local_custom_headers_enable_button, font);
fl_set_object_lstyle(fdui -> url_form_delete_button, font);
fl_set_object_lstyle(fdui -> url_form_clear_button, font);
fl_set_object_lstyle(fdui -> url_form_add_button, font);
fl_set_object_lstyle(fdui -> url_form_browse_online_button, font);
fl_set_object_lstyle(fdui -> url_form_get_daily_button, font);
fl_set_object_lstyle(fdui -> url_form_get_pictures_button, font);
fl_set_object_lstyle(fdui -> url_form_host_only_button, font);
fl_set_object_lstyle(fdui -> url_form_external_browser_button, font);
fl_set_object_lstyle(fdui -> url_form_search_case_button, font);
fl_set_object_lstyle(fdui -> url_form_search_button, font);
fl_set_object_lstyle(fdui -> url_form_show_marked_only_button, font);
fl_set_object_lstyle(fdui -> highlight_postings_button, font);
fl_set_object_lstyle(fdui -> highlight_articles_button, font);
fl_set_object_lstyle(fdui -> highlight_headers_button, font);
fl_set_object_lstyle(fdui -> highlight_headers_from_button, font);
fl_set_object_lstyle(fdui -> highlight_headers_to_button, font);
fl_set_object_lstyle(fdui -> highlight_headers_subject_button, font);
fl_set_object_lstyle(fdui -> highlight_headers_references_button, font);
fl_set_object_lstyle(fdui -> highlight_headers_others_button, font);
fl_set_object_lstyle(fdui -> highlight_case_sensitive_button, font);
fl_set_object_lstyle(fdui -> highlight_urls_button, font);
fl_set_object_lstyle(fdui -> highlight_urls_url_button, font);
fl_set_object_lstyle(fdui -> highlight_urls_description_button, font);
fl_set_object_lstyle(fdui -> newsserver_form_delete_button, font);
fl_set_object_lstyle(fdui -> newsserver_form_add_button, font);
fl_set_object_lstyle(fdui -> posting_period_form_delete_button, font);
fl_set_object_lstyle(fdui -> posting_period_form_add_button, font);
fl_set_object_lstyle(fdui -> posting_period_form_accept_button, font);
fl_set_object_lstyle(fdui -> fonts_form_font_button_group, font);
fl_set_object_lstyle(fdui -> fonts_form_global_fonts_button, font);
fl_set_object_lstyle(fdui -> fonts_form_article_fonts_button, font);
fl_set_object_lstyle(fdui -> setup_form_autosig_button, font);                  
//fl_set_object_lstyle(fdui -> highlight_bodies_button, font);
//fl_set_object_lstyle(fdui -> highlight_attachments_button, font);
//fl_set_object_lstyle(fdui -> incoming_mail_form_mark_read_button, font);

XSync(fl_get_display(), 0);

/* refresh the X screen to show the new fonts */
sprintf(temp, "xrefresh");
pptr = popen(temp, "w");
pclose(pptr);

return 1;
} /* end function set_global_fonts */


int set_font_radio_buttons(int mode)
{
switch(mode)
	{
	case ARTICLE_FONTS:
		fl_set_button(fdui -> fonts_form_article_fonts_button, 1);
		break;
	case GLOBAL_FONTS:
		fl_set_button(fdui -> fonts_form_global_fonts_button, 1);
		break;
	case DEFAULT_FONTS:
		fl_set_button(fdui -> fonts_form_default_fonts_button, 1);
		break;
	} /* end switch font_mode */		

return 1;
} /* end function set_font_radio_buttons */

